]> code.delx.au - gnu-emacs/blob - make-dist
* make-dist: Make a `site-lisp' directory in the distribution,
[gnu-emacs] / make-dist
1 #!/bin/sh
2
3 #### make-dist: create an Emacs distribution tar file from the current
4 #### source tree. This basically creates a duplicate directory
5 #### structure, and then hard links into it only those files that should
6 #### be distributed. This means that if you add a file with an odd name,
7 #### you should make sure that this script will include it.
8
9 progname="$0"
10
11 ### Exit if a command fails.
12 ### set -e
13
14 ### Print out each line we read, for debugging's sake.
15 ### set -v
16
17 clean_up=yes
18 make_tar=yes
19 newer=""
20
21 while [ $# -gt 0 ]; do
22 case "$1" in
23 ## This option tells make-dist not to delete the staging directory
24 ## after it's done making the tar file.
25 "--no-clean-up" )
26 clean_up=no
27 ;;
28 ## This option tells make-dist not to make a tar file. Since it's
29 ## rather pointless to build the whole staging directory and then
30 ## nuke it, using this option also selects '--no-clean-up'.
31 "--no-tar" )
32 make_tar=no
33 clean_up=no
34 ;;
35 ## This option tells make-dist to make the distribution normally, then
36 ## remove all files older than the given timestamp file. This is useful
37 ## for creating incremental or patch distributions.
38 "--newer")
39 newer="$2"
40 new_extension=".new"
41 shift
42 ;;
43 ## This option tells make-dist to use `compress' instead of gzip.
44 ## Normally, make-dist uses gzip whenever it is present.
45 "--compress")
46 default_gzip="compress"
47 ;;
48 * )
49 echo "${progname}: Unrecognized argument: $1" >&2
50 exit 1
51 ;;
52 esac
53 shift
54 done
55
56 ### Make sure we're running in the right place.
57 if [ ! -d src -o ! -f src/lisp.h -o ! -d lisp -o ! -f lisp/version.el ]; then
58 echo "${progname}: Can't find \`src/lisp.h' and \`lisp/version.el'." >&2
59 echo "${progname} must be run in the top directory of the Emacs" >&2
60 echo "distribution tree. Cd to that directory and try again." >&2
61 exit 1
62 fi
63
64 ### Find out which version of Emacs this is.
65 version=`grep 'defconst[ ]*emacs-version' lisp/version.el \
66 | sed -e 's/^.*"\([0-9][0-9]*\.[0-9][0-9]*\)\..*$/\1/'`
67 if [ ! "${version}" ]; then
68 echo "${progname}: can't find current emacs version in \`./lisp/version.el'." >&2
69 exit 1
70 fi
71
72 if grep -s "GNU Emacs version ${version}" ./man/emacs.texi > /dev/null; then
73 true
74 else
75 echo "You must update the version number in \`./man/emacs.texi'"
76 exit 1
77 fi
78
79 ### Make sure the subdirectory is available.
80 tempparent="make-dist.tmp.$$"
81 if [ -d ${tempparent} ]; then
82 echo "${progname}: staging directory \`${tempparent}' already exists.
83 Perhaps a previous invocation of \`${progname}' failed to clean up after
84 itself. Check that directories whose names are of the form
85 \`make-dist.tmp.NNNNN' don't contain any important information, remove
86 them, and try again." >&2
87 exit 1
88 fi
89
90 ### Check for .elc files with no corresponding .el file.
91 ls -1 lisp/*.el | sed 's/\.el$/.elc/' > /tmp/el
92 ls -1 lisp/*.elc > /tmp/elc
93 bogosities="`comm -13 /tmp/el /tmp/elc`"
94 if [ "${bogosities}" != "" ]; then
95 echo "The following .elc files have no corresponding .el files:"
96 echo "${bogosities}"
97 fi
98 rm -f /tmp/el /tmp/elc
99
100 echo "Creating staging directory: \`${tempparent}'"
101 mkdir ${tempparent}
102 emacsname="emacs-${version}${new_extension}"
103 tempdir="${tempparent}/${emacsname}"
104
105 ### This trap ensures that the staging directory will be cleaned up even
106 ### when the script is interrupted in mid-career.
107 if [ "${clean_up}" = yes ]; then
108 trap "echo 'Interrupted...cleaning up the staging directory.'; rm -rf ${tempparent}; exit 1" 1 2 15
109 fi
110
111 echo "Creating top directory: \`${tempdir}'"
112 mkdir ${tempdir}
113
114 ### We copy in the top-level files before creating the subdirectories in
115 ### hopes that this will make the top-level files appear first in the
116 ### tar file; this means that people can start reading the INSTALL and
117 ### README while the rest of the tar file is still unpacking. Whoopee.
118 echo "Making links to top-level files."
119 ln GETTING.GNU.SOFTWARE INSTALL PROBLEMS README move-if-change ${tempdir}
120 ln ChangeLog Makefile.in build-install.in configure configure.in ${tempdir}
121 ln make-dist ${tempdir}
122 ### Copy config.sub; it's a cross-filesystem symlink.
123 cp config.sub ${tempdir}
124
125 echo "Updating version number in README."
126 (cd ${tempdir}
127 awk \
128 '$1 " " $2 " " $3 " " $4 " " $5 == "This directory tree holds version" { $6 = version; print $0 }
129 $1 " " $2 " " $3 " " $4 " " $5 != "This directory tree holds version"' \
130 version=${version} README > tmp.README
131 mv tmp.README README)
132
133
134 echo "Creating subdirectories."
135 # I think we're not going to distribute anything in external-lisp, so
136 # I've removed it from this list.
137 for subdir in lisp lisp/term site-lisp \
138 src src/m src/s src/bitmaps lib-src oldXMenu \
139 etc lock cpp info man shortnames vms; do
140 mkdir ${tempdir}/${subdir}
141 done
142
143 echo "Making links to \`lisp'."
144 ### Don't distribute TAGS, =*.el files, site-init.el, site-load.el, or default.el.
145 (cd lisp
146 ln [a-zA-Z]*.el ../${tempdir}/lisp
147 ln [a-zA-Z]*.elc ../${tempdir}/lisp
148 ## simula.el doesn't keep abbreviations in simula.defns any more.
149 ## ln [a-zA-Z]*.defns ../${tempdir}/lisp
150 ln ChangeLog README ../${tempdir}/lisp
151 cd ../${tempdir}/lisp
152 rm -f TAGS =*
153 rm -f site-init site-init.el site-init.elc
154 rm -f site-load site-load.el site-load.elc
155 rm -f default default.el default.elc)
156
157 #echo "Making links to \`lisp/calc-2.02'."
158 #### Don't distribute =*.el files, TAGS or backups.
159 #(cd lisp/calc-2.02
160 # ln [a-zA-Z]*.el ../../${tempdir}/lisp/calc-2.02
161 # ln [a-zA-Z]*.elc ../../${tempdir}/lisp/calc-2.02
162 # ln calc.info* calc.texinfo calc-refcard.* ../../${tempdir}/lisp/calc-2.02
163 # ln INSTALL Makefile README README.prev ../../${tempdir}/lisp/calc-2.02
164 # cd ../../${tempdir}/lisp/calc-2.02
165 # rm -f *~ TAGS)
166
167 echo "Making links to \`lisp/term'."
168 ### Don't distribute =*.el files or TAGS.
169 (cd lisp/term
170 ln [a-zA-Z]*.el ../../${tempdir}/lisp/term
171 ln [a-zA-Z]*.elc ../../${tempdir}/lisp/term
172 ln README ChangeLog ../../${tempdir}/lisp/term
173 rm -f =* TAGS)
174
175 ### echo "Making links to \`external-lisp'."
176 ### ### Don't distribute =*.el files or TAGS.
177 ### (cd external-lisp
178 ### ln [a-zA-Z]*.el ../${tempdir}/external-lisp
179 ### ln [a-zA-Z]*.elc ../${tempdir}/external-lisp
180 ### ln ChangeLog README ../${tempdir}/external-lisp
181 ### rm -f =* TAGS)
182
183 echo "Making links to \`src'."
184 ### Don't distribute =*.[ch] files, or the configured versions of
185 ### config.h.in, paths.h.in, or Makefile.in, or TAGS.
186 (cd src
187 echo " (If we can't link gmalloc.c, that's okay.)"
188 ln [a-zA-Z]*.c ../${tempdir}/src
189 ## Might be a symlink to a file on another filesystem.
190 test -f ../${tempdir}/src/gmalloc.c || cp gmalloc.c ../${tempdir}/src
191 ln [a-zA-Z]*.h ../${tempdir}/src
192 ln [a-zA-Z]*.s ../${tempdir}/src
193 ln README Makefile.in ymakefile ChangeLog config.h.in paths.h.in \
194 ../${tempdir}/src
195 ln .gdbinit .dbxinit ../${tempdir}/src
196 ln *.opt vms-pp.trans ../${tempdir}/src
197 cd ../${tempdir}/src
198 rm -f config.h paths.h Makefile
199 if [ -z "${newer}" ]; then
200 etags *.h *.c ../lisp/*.el
201 fi
202 rm -f =* TAGS)
203
204 echo "Making links to \`src/bitmaps'."
205 (cd src/bitmaps
206 ln README *.xbm ../../${tempdir}/src/bitmaps)
207
208 echo "Making links to \`src/m'."
209 (cd src/m
210 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/m)
211
212 echo "Making links to \`src/s'."
213 (cd src/s
214 ln README [a-zA-Z0-9]*.h ../../${tempdir}/src/s)
215
216 echo "Making links to \`lib-src'."
217 (cd lib-src
218 ln [a-zA-Z]*.[chy] [a-zA-Z]*.lex ../${tempdir}/lib-src
219 ln ChangeLog Makefile.in README testfile vcdiff rcs2log ../${tempdir}/lib-src
220 ln emacs.csh rcs-checkin ../${tempdir}/lib-src
221 cd ../${tempdir}/lib-src
222 rm -f getdate.c getdate.tab.c y.tab.c y.tab.h
223 rm -f =* TAGS)
224
225 echo "Making links to \`oldXMenu'."
226 (cd oldXMenu
227 ln *.c *.h *.in ../${tempdir}/oldXMenu
228 ln README Imakefile ChangeLog ../${tempdir}/oldXMenu
229 ln compile.com descrip.mms ../${tempdir}/oldXMenu)
230
231 echo "Making links to \`etc'."
232 ### Don't distribute = files, TAGS, DOC files, backups, autosaves, or
233 ### tex litter.
234 (cd etc
235 ln `ls -d * | grep -v 'RCS' | grep -v 'Old'` ../${tempdir}/etc
236 cd ../${tempdir}/etc
237 rm -f DOC* *~ \#*\# *.dvi *.log *,v =* core
238 rm -f TAGS)
239
240 echo "Making links to \`cpp'."
241 (cd cpp
242 ln cccp.c cexp.y Makefile README ../${tempdir}/cpp)
243
244 echo "Making links to \`info'."
245 # Don't distribute backups or autosaves.
246 (cd info
247 ln [a-zA-Z]* ../${tempdir}/info
248 cd ../${tempdir}/info
249 # Avoid an error when expanding the wildcards later.
250 ln emacs dummy~ ; ln emacs \#dummy\#
251 rm -f *~ \#*\# core)
252
253 echo "Making links to \`man'."
254 (cd man
255 ln *.texinfo *.texi *.aux *.cps *.fns *.kys *.vrs ../${tempdir}/man
256 test -f README && ln README ../${tempdir}/man
257 test -f Makefile && ln Makefile ../${tempdir}/man
258 ln ChangeLog split-man ../${tempdir}/man
259 cp texinfo.tex texindex.c ../${tempdir}/man
260 cd ../${tempdir}/man
261 rm -f \#*\# =* *~ core emacs-index* *.Z *.z xmail
262 rm -f emacs.?? termcap.?? gdb.?? *.log *.toc *.dvi *.oaux)
263
264 echo "Making links to \`shortnames'."
265 (cd shortnames
266 ln *.c ../${tempdir}/shortnames
267 ln Makefile reserved special ../${tempdir}/shortnames)
268
269 echo "Making links to \`vms'."
270 (cd vms
271 ln [0-9a-zA-Z]* ../${tempdir}/vms
272 cd ../${tempdir}/vms
273 rm -f *~)
274
275 ### It would be nice if they could all be symlinks to etc's copy, but
276 ### you're not supposed to have any symlinks in distribution tar files.
277 echo "Making sure copying notices are all copies of \`etc/COPYING'."
278 rm -f ${tempdir}/etc/COPYING
279 cp etc/COPYING ${tempdir}/etc/COPYING
280 # I think we're not going to distribute anything in external-lisp, so
281 # I've removed it from this list.
282 for subdir in lisp src lib-src info shortnames; do
283 if [ -f ${tempdir}/${subdir}/COPYING ]; then
284 rm ${tempdir}/${subdir}/COPYING
285 fi
286 cp etc/COPYING ${tempdir}/${subdir}
287 done
288
289 #### Make sure that there aren't any hard links between files in the
290 #### distribution; people with afs can't deal with that. Okay,
291 #### actually we just re-copy anything with a link count greater
292 #### than two.
293 echo "Breaking intra-tree links."
294 find ${tempdir} ! -type d -links +2 \
295 -exec cp {} $$ \; -exec rm -f {} \; -exec mv $$ {} \;
296
297 if [ "${newer}" ]; then
298 echo "Removing files older than $newer."
299 ## We remove .elc files unconditionally, on the theory that anyone picking
300 ## up an incremental distribution already has a running Emacs to byte-compile
301 ## them with.
302 find ${tempparent} \( -name '*.elc' -o ! -newer ${newer} \) -exec rm -f {} \;
303 fi
304
305 if [ "${make_tar}" = yes ]; then
306 if [ "${default_gzip}" = "" ]; then
307 echo "Looking for gzip."
308 temppath=`echo $PATH | sed 's/^:/.:/
309 s/::/:.:/g
310 s/:$/:./
311 s/:/ /g'`
312 default_gzip=`(
313 for dir in ${temppath}; do
314 if [ -f ${dir}/gzip ]; then echo 'gzip --best'; exit 0; fi
315 done
316 echo compress
317 )`
318 fi
319 case "${default_gzip}" in
320 compress* ) gzip_extension=.Z ;;
321 * ) gzip_extension=.z ;;
322 esac
323 echo "Creating tar file."
324 (cd ${tempparent} ; tar cvf - ${emacsname} ) \
325 | ${default_gzip} \
326 > ${emacsname}.tar${gzip_extension}
327 fi
328
329 if [ "${clean_up}" = yes ]; then
330 echo "Cleaning up the staging directory."
331 rm -rf ${tempparent}
332 fi
333
334 ### make-dist ends here